/* Dark Well - old-good game, mod of tetris.
 * Copyright (C) 2000 Boris Kozlov.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <curses.h>
#include "draw.h"

typedef unsigned char vec[3];

int highascii[15][11] = { 
               218,191,192,217,196,179,195,180,193,194,197,     /* single */
               201,187,200,188,205,186,204,185,202,203,206, /* double horizontal */
               214,183,211,189,196,186,199,182,208,210,215,   /* double vertical */
               213,184,212,190,205,179,198,181,207,209,216,  /* double horiz */
               176,177,178,219,220,223,221,222,22,254,32,   /* solid blocks */     
               197,206,215,216,1,2,3,4,5,6,32,
               16,17,18,19,21,23,25,29,30,31,32,
               28,168,127,128,129,130,131,132,133,134,32,
               135,136,137,138,139,140,141,142,143,144,32,
               145,146,147,148,149,150,151,152,153,154,32,
               155,156,157,158,159,160,161,162,163,164,32,
               165,166,167,169,170,171,172,173,174,175,32,             
               224,225,226,227,228,229,230,231,232,233,32,
               234,235,236,237,238,239,240,241,242,243,32,
               244,245,246,247,248,249,250,251,252,253,32
};

#define x1 28
#define x0 x1-1

#define y1 1 
#define y0 y1-1

#define width 26  
// width must be not odd and width/2 must be odd !
#define height 22

static int colour=0;

void usecolor(int colnum,int other_attr)
{
if(colnum==0)
  attrset(A_NORMAL);
else
  if(colour)
    attrset(COLOR_PAIR(colnum)|other_attr);
  else
    attrset(other_attr);
}

void define_colours()
{
  int f;

  /* make it use color */
  start_color();
  colour=has_colors();
  if(!colour) return;
  /* declare color pairs we need */
  for(f=1;f<=7;f++) init_pair(f,f,0);
}

void drawwell()
{
  int y,x;
  clear();
  
  setcolor(9);
  wr("Top Ten",1,0);  
  wr("Next colors",15,56);    
  wr("Stats",1,56);  
  wr("Amounts",7,56);    
  wr("Quick help",14,0);    

  setcolor(10);  
  wr("Score       : ",3,61);  
  wr("Speed       : ",4,61);
  setcolor(2);    
  wr("Max in turn : ",5,61);
  wr("down        : ",9,61);	     
  wr("right       : ",10,61);	     	     
  wr("down-left   : ",11,61);	     	     	     
  wr("down-right  : ",12,61);	     	     	     
  setcolor(10);    
  wr("total       : ",13,61);	     	     	       
  
  setcolor(10);
  for (x=0;x<x0-1;x++) wrc(highascii[2][4],2,x); //horiz
  for (x=56;x<80;x++) wrc(highascii[2][4],16,x); //horiz  
  for (x=56;x<80;x++) wrc(highascii[2][4],2,x); //horiz
  for (x=56;x<80;x++) wrc(highascii[2][4],8,x); //horiz  
  for (x=0;x<x0-1;x++) wrc(highascii[2][4],15,x); //horiz  
  
  setcolor(2);
  for (y=y0;y<height+y0+1;y++) wrc(highascii[2][5],y,x0);  //vert
  for (y=y0;y<height+y0+1;y++) wrc(highascii[2][5],y,x0+width+1); //vert

  for (x=x0;x<width+x0+1;x++) wrc(highascii[2][4],y0+height+1,x); //hor
  for (x=x0;x<width+x0+1;x++) wrc(highascii[2][4],y0,x);  //hor

  wrc(highascii[2][0],y0,x0);         //angles
  wrc(highascii[2][1],y0,x0+width+1);
  wrc(highascii[2][2],y0+height+1,x0);
  wrc(highascii[2][3],y0+height+1,x0+width+1);
  
  refresh();
}

